package ut.maxorato.bsc.crawler.analysis;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import ut.maxorato.bsc.crawler.model.UrlTemplate;

import java.util.Iterator;
import java.util.Map;

public class TemplateMapFilter implements Runnable {
    private static final Logger log = LoggerFactory.getLogger(GroupTemplateFilter.class);

    private final Map<String, UrlTemplate> templateMap;
    private final TemplateFilter filter;

    public TemplateMapFilter(Map<String, UrlTemplate> templateMap, TemplateFilter filter) {
        this.templateMap = templateMap;
        this.filter = filter;
    }

    @Override
    public void run() {
        int initialTemplateCount = 0;

        for (Iterator<Map.Entry<String, UrlTemplate>> iterator = templateMap.entrySet().iterator(); iterator.hasNext();) {
            Map.Entry<String, UrlTemplate> entry = iterator.next();
            initialTemplateCount++;

            if (!filter.accept(entry.getValue())) {
                iterator.remove();
            }
        }

        log.info("Changed from {} templates to {} templates with filter {}", initialTemplateCount, templateMap.size(), filter.getClass().getSimpleName());
    }
}
