package ut.maxorato.bsc.crawler.diff;

import java.util.List;

public class DomDifference {
    private final List<Integer> path;
    private final String baseText;
    private final String otherText;

    public DomDifference(List<Integer> path, String baseText, String otherText) {
        this.path = path;
        this.baseText = baseText;
        this.otherText = otherText;
    }

    public boolean isPrefixOf(DomDifference other, boolean strict) {
        if (strict && other.path.size() <= path.size() || !strict && other.path.size() < path.size()) {
            return false;
        }

        for (int i = 0; i < path.size(); i++) {
            if ((int)path.get(i) != other.path.get(i)) {
                return false;
            }
        }

        return true;
    }

    public boolean isMatch(DomDifference other) {
        if (other.path.size() != path.size()) {
            return false;
        }

        for (int i = 0; i < path.size(); i++) {
            if ((int)path.get(i) != other.path.get(i)) {
                return false;
            }
        }

        return true;
    }
}
